' FileName: CvPC2VBx.Bas
' Date: 8/19/2018
' Author: Ben Ritchey
' Description: Convert MS Virtual PC Syntax to Oracles VBox (.Bat files)

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

FUNCTION PBMAIN () AS LONG

Local L, Do1Flag, B, RC as Long
Local D, DList, BB, NewDo, C, AA, A, PgmVer as String

' Do NOT change format of next line except x-x !!!
  PgmVer=" CvPC2VBx v1.3.B "

Print PgmVer;" (c) 2018 BDR  Args=[ ";command$;" ]"

RC=0

  DList="C": On Error Resume Next
  for L=68 to 90
    ChDrive Chr$(L)
    If Err=0 then DList=DList+Chr$(L): else Errclear
   Next L 
  On Error Goto 0
  ChDrive "C"

Open "CvPC2VBx.Log" for append as #4
Print #4,"======== Started scan on ";date$;" at ";time$;" ========"
Print "*** Drives found: ";DList
Print #4,"*** Drives found: ";DList

BB=trim$(ucase$(command$))

If BB<>"" then
  If not isfile(BB) then
    Print "*** Error: file [ ";BB;" ] not found."
    Print #4,"*** Error: file [ ";BB;" ] not found."
    RC=1: beep
    goto EndLog
  End if

  Do1Flag=1
  Print "-=> Validated  file [ ";BB;" ] "
  Print #4,"-=> Validated  file [ ";BB;" ] "

  Open "DoMeBats.temp" for output as #5
  Print#5,BB
  Close #5
  Open "domebats.temp" for input as #1
  Goto Anyfile
End if  

If not isfile("domebats.do") then
  Print "*** Error: file [ DoMeBats.Do ] not found."
  Print #4,"*** Error: file [ DoMeBats.Do ] not found."
  beep: RC=1
  goto EndLog
End if

Open "domebats.do" for input as #1

Anyfile:

While not eof(1)
  A=""
  Line input#1,A
  If mid$(A,1,1)="#" then goto FileDo
  If not isfile(A) goto FileDo

  NewDo=trim$(A)+".NewDo"
  Open A for Input as #2
  Open NewDo for Output as #3

  Print "-=> Converting file [ ";A;" ] to [ ";NewDo;" ] "
  Print #4,"-=> Converting file [ ";A;" ] to [ ";NewDo;" ] "

While not eof(2)

  A=""
  Line input#2,A

SameDo:
  AA=trim$(ucase$(A))

  If A="" or AA="" then goto NoDo
  B=instr(AA,"\\TSCLIENT\")
  If B=0 then goto NoDo

  AA=ucase$(A)

For L=1 to Len(DList)
  D=mid$(DList,L,1)

  B=instr(AA,"\\TSCLIENT\"+D+"\")
  If B=0 then goto NoDL

  If B>1 then C=mid$(A,1,B-1) else C=""
  C=C+"\\Vboxsrv\"+D+"_drive\"+mid$(A,B+13)
  A=C: goto SameDo

NoDL:

Next L

For L=1 to 9

  D=trim$(str$(L))
  B=instr(AA,"\\TSCLIENT\%"+D+"\")
  If B=0 then goto NoArg

  If B>1 then C=mid$(A,1,B-1) else C=""
  C=C+"\\Vboxsrv\%"+D+"_drive\"+mid$(A,B+14)
  A=C: goto SameDo

NoArg:

Next L

ErrDo:

Print "* Error: Check File ";NewDo;" for bad \\TSclient\?\ ..."
Print #4,"* Error: Check File ";NewDo;" for bad \\TSclient\?\ ..."
If mid$(AA,1,3)<>"REM" then A="Rem "+A
Print #4,"* Data = ";A

NoDo:

  Print #3,A

NextDo:

WEnd

Close 2,3

FileDo:

Wend

EndLog:

Print #4,"========  -=:{ End of scan }:=-  ========"
Close
Print
Input "*** See file CvPC2VBx.Log for errors ... press {Enter}",A
If Do1Flag=1 and isfile("DoMeBats.temp") then kill "DoMeBats.temp"

ENDITALL:

End RC
END FUNCTION

' End of CvPC2VBx.Bas

